<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfVideoDeviceWirelessHistory ArrayType
 * @subpackage Arrays
 */
class ArrayOfVideoDeviceWirelessHistory extends AbstractStructArrayBase
{
    /**
     * The VideoDeviceWirelessHistory
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\VideoDeviceWirelessHistory[]
     */
    public $VideoDeviceWirelessHistory;
    /**
     * Constructor method for ArrayOfVideoDeviceWirelessHistory
     * @uses ArrayOfVideoDeviceWirelessHistory::setVideoDeviceWirelessHistory()
     * @param \CustomerManagement\StructType\VideoDeviceWirelessHistory[] $videoDeviceWirelessHistory
     */
    public function __construct(array $videoDeviceWirelessHistory = array())
    {
        $this
            ->setVideoDeviceWirelessHistory($videoDeviceWirelessHistory);
    }
    /**
     * Get VideoDeviceWirelessHistory value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\VideoDeviceWirelessHistory[]|null
     */
    public function getVideoDeviceWirelessHistory()
    {
        return isset($this->VideoDeviceWirelessHistory) ? $this->VideoDeviceWirelessHistory : null;
    }
    /**
     * This method is responsible for validating the values passed to the setVideoDeviceWirelessHistory method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVideoDeviceWirelessHistory method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVideoDeviceWirelessHistoryForArrayConstraintsFromSetVideoDeviceWirelessHistory(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfVideoDeviceWirelessHistoryVideoDeviceWirelessHistoryItem) {
            // validation for constraint: itemType
            if (!$arrayOfVideoDeviceWirelessHistoryVideoDeviceWirelessHistoryItem instanceof \CustomerManagement\StructType\VideoDeviceWirelessHistory) {
                $invalidValues[] = is_object($arrayOfVideoDeviceWirelessHistoryVideoDeviceWirelessHistoryItem) ? get_class($arrayOfVideoDeviceWirelessHistoryVideoDeviceWirelessHistoryItem) : sprintf('%s(%s)', gettype($arrayOfVideoDeviceWirelessHistoryVideoDeviceWirelessHistoryItem), var_export($arrayOfVideoDeviceWirelessHistoryVideoDeviceWirelessHistoryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VideoDeviceWirelessHistory property can only contain items of type \CustomerManagement\StructType\VideoDeviceWirelessHistory, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VideoDeviceWirelessHistory value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\VideoDeviceWirelessHistory[] $videoDeviceWirelessHistory
     * @return \CustomerManagement\ArrayType\ArrayOfVideoDeviceWirelessHistory
     */
    public function setVideoDeviceWirelessHistory(array $videoDeviceWirelessHistory = array())
    {
        // validation for constraint: array
        if ('' !== ($videoDeviceWirelessHistoryArrayErrorMessage = self::validateVideoDeviceWirelessHistoryForArrayConstraintsFromSetVideoDeviceWirelessHistory($videoDeviceWirelessHistory))) {
            throw new \InvalidArgumentException($videoDeviceWirelessHistoryArrayErrorMessage, __LINE__);
        }
        if (is_null($videoDeviceWirelessHistory) || (is_array($videoDeviceWirelessHistory) && empty($videoDeviceWirelessHistory))) {
            unset($this->VideoDeviceWirelessHistory);
        } else {
            $this->VideoDeviceWirelessHistory = $videoDeviceWirelessHistory;
        }
        return $this;
    }
    /**
     * Add item to VideoDeviceWirelessHistory value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\VideoDeviceWirelessHistory $item
     * @return \CustomerManagement\ArrayType\ArrayOfVideoDeviceWirelessHistory
     */
    public function addToVideoDeviceWirelessHistory(\CustomerManagement\StructType\VideoDeviceWirelessHistory $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\VideoDeviceWirelessHistory) {
            throw new \InvalidArgumentException(sprintf('The VideoDeviceWirelessHistory property can only contain items of type \CustomerManagement\StructType\VideoDeviceWirelessHistory, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VideoDeviceWirelessHistory[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\VideoDeviceWirelessHistory|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\VideoDeviceWirelessHistory|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\VideoDeviceWirelessHistory|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\VideoDeviceWirelessHistory|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\VideoDeviceWirelessHistory|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string VideoDeviceWirelessHistory
     */
    public function getAttributeName()
    {
        return 'VideoDeviceWirelessHistory';
    }
}
